# Generated by Django 4.0.5 on 2022-08-18 16:23

from django.conf import settings
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import wagtail.images.models
import wagtail.search.index


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Icon',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(blank=True, max_length=255, verbose_name='title')),
                ('file', models.FileField(upload_to=wagtail.images.models.get_upload_to, validators=[django.core.validators.FileExtensionValidator(allowed_extensions=['svg'])], verbose_name='file')),
                ('created_at', models.DateTimeField(auto_now_add=True, db_index=True, verbose_name='created at')),
                ('file_size', models.PositiveIntegerField(editable=False, null=True)),
                ('uploaded_by_user', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL, verbose_name='uploaded by user')),
            ],
            bases=(wagtail.search.index.Indexed, models.Model),
        ),
        migrations.CreateModel(
            name='Group',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(max_length=255, unique=True, verbose_name='title')),
                ('slug', models.CharField(max_length=255, unique=True)),
                ('edited', models.DateTimeField(auto_now=True, verbose_name='edited')),
                ('created_at', models.DateTimeField(auto_now=True, db_index=True)),
                ('icons', models.ManyToManyField(blank=True, to='wagtail_icons.icon')),
            ],
        ),
    ]
